<?php
/**
 * Fired when the plugin is uninstalled.
 *
 * When populating this file, consider the following flow
 * of control:
 *
 * - This method should be static
 * - Check if the $_REQUEST content actually is the plugin name
 * - Run an admin referrer check to make sure it goes through authentication
 * - Verify the output of $_GET makes sense
 * - Repeat with other user roles. Best directly by using the links/query string parameters.
 * - Repeat things for multisite. Once for a single site in the network, once sitewide.
 *
 * This file may be updated more in future version of the Boilerplate; however, this is the
 * general skeleton and outline for how the file should work.
 *
 * For more information, see the following discussion:
 * https://github.com/tommcfarlin/WordPress-Plugin-Boilerplate/pull/123#issuecomment-28541913
 *
 * @link       https://divisupreme.com
 * @since      1.0.0
 *
 * @package    Dsm_Supreme_Modules_Pro_For_Divi
 */

// If uninstall not called from WordPress, then exit.
if ( ! defined( 'WP_UNINSTALL_PLUGIN' ) ) {
	exit;
}

if ( isset( get_option( 'dsm_settings_misc' )['dsm_uninstall_on_delete'] ) && 'on' === get_option( 'dsm_settings_misc' )['dsm_uninstall_on_delete'] ) {
	delete_option( 'dsm_general' );
	delete_option( 'dsm_settings_social_media' );
	delete_option( 'dsm_settings_misc' );
	delete_option( 'dsm_license' );
	delete_option( 'dsm_license_key' );
	delete_option( 'dsm_license_status' );
	delete_option( 'widget_dsm_widget_library' );
}
